﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Net;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Animation;
using System.Windows.Shapes;
using Telerik.Windows.Controls;
using Telerik.Windows.Data;
using System.Windows.Media.Imaging;
using Telerik.Windows.Controls.GridView;
using System.Linq;

namespace RadGridView_SL4_AR_23
{
	public partial class MainPage : UserControl
	{
		private RadObservableCollection<Player> data = new RadObservableCollection<Player>();
		private List<int> positions = new List<int>() { 1, 2, 3, 4, 5, 6, 7, 8, 9, 10, 11, 12, 13, 14 };

		public MainPage()
		{
			InitializeComponent();

			this.playersGrid.ItemsSource = Player.GetPlayers();
			this.playersGrid.SizeChanged += new SizeChangedEventHandler(playersGrid_SizeChanged);
			this.playersGrid.Loaded += new RoutedEventHandler(playersGrid_Loaded);

			for (int i = 0; i < 10; i++)
			{
				var column = new GridViewDataColumn();

				column.DataMemberBinding = new System.Windows.Data.Binding("Number");

				this.playersGrid.Columns.Add(column);
			}

		}

		void playersGrid_SizeChanged(object sender, SizeChangedEventArgs e)
		{
			if (this.viewer == null)
			{
				this.InitializeViewerAndPageSize();
			}
			else
			{
				this.SetPageSize();
			}
		}

		private void SetPageSize() 
		{
			if (this.viewer == null)
				return;

			var availableViewport = this.viewer.ViewportHeight;
			var maxNumberOfRows = (int) (availableViewport / this.playersGrid.RowHeight);

			if (maxNumberOfRows == 0)
				maxNumberOfRows = 1;

			this.playersGrid.Items.PageSize = maxNumberOfRows;
		}

		private void InitializeViewerAndPageSize()
		{
			this.Dispatcher.BeginInvoke(new Action(() => 
			{
				this.viewer = this.playersGrid.ChildrenOfType<GridViewScrollViewer>().FirstOrDefault();
				this.SetPageSize();
			
			}));
		}

		private GridViewScrollViewer viewer;

		void playersGrid_Loaded(object sender, RoutedEventArgs e)
		{
			this.viewer = this.playersGrid.ChildrenOfType<GridViewScrollViewer>().FirstOrDefault();
		}

		private void Button1_Click(object sender, RoutedEventArgs e)
		{
			
		}

		private void Button2_Click(object sender, RoutedEventArgs e)
		{

		}
	}
}
